#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define len(x) (int)(x).size()
#define y1 y1337
using namespace std;

const int N = 10;
int n;
vector<string> field;
bool used[N][N];

int x1, x2, y1, y2;

array<int, 4> dfs(array<int, 4> x, int i, int j) {
    if (i < x1 || i > x2 || j < y1 || j > y2 || field[i][j] == '#' || used[i][j]) {
        return x;
    }
    used[i][j] = true;
    x[0] = min(x[0], i);
    x[1] = min(x[1], j);
    x[2] = max(x[2], i);
    x[3] = max(x[3], j);
    x = dfs(x, i - 1, j);
    x = dfs(x, i + 1, j);
    x = dfs(x, i, j - 1);
    x = dfs(x, i, j + 1);
    return x;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    field.resize(n);
    for (auto &i: field) {
        cin >> i;
    }
    reverse(all(field));
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            swap(field[i][j], field[j][i]);
        }
    }

    x1 = n, x2 = 0, y1 = n, y2 = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (field[i][j] == '#') {
                x1 = min(x1, i);
                y1 = min(y1, j);
                x2 = max(x2, i);
                y2 = max(y2, j);
            }
        }
    }
    if (x1 == n) {
        cout << "X" << endl;
        return 0;
    }

    vector<array<int, 4>> del;
    for (int i = x1; i <= x2; i++) {
        for (int j = y1; j <= y2; j++) {
            if (field[i][j] == '.' && !used[i][j]) {
                del.push_back(dfs(array<int, 4>{i, j, i, j}, i, j));
            }
        }
    }

    vector<string> tar(n, string(n, '.'));
    for (int i = x1; i <= x2; i++) {
        for (int j = y1; j <= y2; j++) {
            tar[i][j] = '#';
        }
    }
    for (auto[x3, y3, x4, y4]: del) {
        for (int i = x3; i <= x4; i++) {
            for (int j = y3; j <= y4; j++) {
                tar[i][j] = '.';
            }
        }
    }
    x2++, y2++;

    if (tar != field) {
        cout << "X" << endl;
    } else if (len(del) == 0) {
        cout << "I" << endl;
    } else if (len(del) == 1) {
        auto[x3, y3, x4, y4] = del[0];
        x4++, y4++;
        if (x1 < x3 && x3 < x4 && x4 < x2 && y1 < y3 && y3 < y4 && y4 < y2) {
            cout << "O" << endl;
        } else if (x1 < x3 && x3 < x4 && x4 == x2 && y1 < y3 && y3 < y4 && y4 < y2) {
            cout << "C" << endl;
        } else if (x1 < x3 && x3 < x4 && x4 == x2 && y1 < y3 && y3 < y4 && y4 == y2) {
            cout << "L" << endl;
        } else {
            cout << "X" << endl;
        }
    } else if (len(del) == 2) {
        auto[x3, y3, x4, y4] = del[0];
        auto[x5, y5, x6, y6] = del[1];
        x4++, y4++, x6++, y6++;
        if (x1 < x3 && x3 == x5 && x5 < x4 && x4 == x6 && x6 < x2 &&
            y1 == y3 && y3 < y4 && y4 < y5 && y5 < y2 && y2 == y6) {
            cout << "H" << endl;
        } else if (x1 < x3 && x3 == x5 && x5 < x6 && x6 < x4 && x4 == x2 &&
                   y1 == y3 && y3 < y4 && y4 < y5 && y5 < y6 && y6 < y2) {
            cout << "P" << endl;
        } else {
            cout << "X" << endl;
        }
    } else {
        cout << "X" << endl;
    }
    return 0;
}
